/*en    Laurent Constantin's network library (lcrzo)
                 lcrzo_type module

  Definitions of standard types.
*/
/*fr    Bibliotheque reseau de Laurent Constantin (lcrzo)
                 Module lcrzo_type

  Definition des types standards.
*/

/*---------------------------------------------------------------*/
/*en integer of 8, 16 and 32 bits*/
/*fr definition d'entiers de 8, 16 et 32 bits*/
typedef char 		lcrzo_int8;
typedef unsigned char 	lcrzo_uint8;
typedef short 		lcrzo_int16;
typedef unsigned short 	lcrzo_uint16;
typedef long 		lcrzo_int32;
typedef unsigned long 	lcrzo_uint32;

/*---------------------------------------------------------------*/
/*en boolean type : 0 or 1*/
/*fr booleen : 0 ou 1*/
#define LCRZO_FALSE 0
#define LCRZO_TRUE  1
typedef int lcrzo_bool;

/*---------------------------------------------------------------*/
/*en the FILE type is necessary to write to a file. It's defined
   in stdio.h, but I do not want to include ".h" files in lcrzo.
   So, we define LCRZOFILE which has the same utility as FILE*/
/*fr le type FILE est normalement necessaire pour indiquer un fichier.
   Il est defini dans stdio.h, mais je n'ai pas envie de l'inclure
   pour les fichiers ".h" publics de lcrzo. D'un point de vue 
   fonctionnement, le LCRZOFILE ci-dessous est identique a FILE.*/
#define LCRZOFILE void
