
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_nntp.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000163=
{ /*reference*/     "lcrzoex", 163,
  /*version*/       1, 2,
  /*title*/         "real tcp client [send newsgroup message]",
  /*french title*/  "client tcp reel [envoi une message de newsgroup]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port 'from@a.b' 'newsgroup' body_filename ['subject']",
  /*french usage*/  "nom_serveur port_serveur  'from@a.b' 'newgroup' fichier_body ['sujet']",
  /*usage example*/ "1.2.3.4 119 'laurent@s.com' 'alt.test' /tmp/file 'here the subject'",
  /*fr. usage ex.*/ "1.2.3.4 119 'laurent@s.com' 'alt.test' /tmp/fichier 'ici, le sujet'",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000163_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000163_main(int argc, char *argv[])
{ lcrzo_ipl ipl;

  if ( argc<6 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000163, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_er(lcrzo_ipl_init_hs(argv[1], &ipl));
  lcrzo_er(shared_nntp_sendmsg_hb_file(ipl, (lcrzo_uint16)atoi(argv[2]),
				       argv[3], argv[3], argv[4], 
				       (argc==6)?"":argv[6], argv[5]));

  return(LCRZO_ERR_OK);
}


