#ifndef LCRZOEX_TELNET_INCLUDED
#define LCRZOEX_TELNET_INCLUDED 1

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_ipc read;
  lcrzo_ipc write;
  lcrzo_ipc controle;
  int pid;
} lcrzo_telnet;

/*-------------------------------------------------------------*/
int shared_telnet_init(lcrzo_ipl serveripl, 
		       lcrzo_uint16 serverport,
		       lcrzo_telnet *ptelnet);
int shared_telnet_close(lcrzo_telnet *ptelnet);

/* note : if login/passord is incorrect, this function automatically
   closes session by calling shared_telnet_close */
int shared_telnet_login(lcrzo_telnet *ptelnet,
			lcrzo_conststring login,
			lcrzo_conststring password);

int shared_telnet_exec(lcrzo_telnet *ptelnet,
		       lcrzo_conststring command,
		       lcrzo_uint32 readtimeout,
		       lcrzo_data *preaddata,
		       lcrzo_int32 *preaddatasize);

int shared_telnet_logout(lcrzo_telnet *ptelnet);



#endif
